<template>
  <el-row :gutter="32">
    <el-col :xs="24" :sm="24" :lg="14" class="small-table">
      <el-table
        :data="registered_location_limited"
        fit
        highlight-current-row
        style="width: 100%;">
        <el-table-column style="width: calc(100% - 170);" align="left">
          <template slot-scope="scope">
            <div class="box" v-bind:style="scope.row.color"></div>
            <span v-if="scope.row.city_name != 0">{{ scope.row.city_name }}</span>
            <span v-if="scope.row.city_name == 0">Belum Memilih Kota</span>
          </template>
        </el-table-column>
        <el-table-column width="90" align="right">
          <template slot-scope="scope">
            <span>{{ (scope.row.percent).toFixed(2) }} %</span>
          </template>
        </el-table-column>
        <el-table-column width="80" align="right">
          <template slot-scope="scope">
            <div class="farmer-count farmer-count--decimal">
              {{ scope.row.farmer_count }}
              <svg-icon icon-class="people-dark-green" />
            </div>
          </template>
        </el-table-column>
      </el-table>
    </el-col>
    <el-col :xs="24" :sm="24" :lg="10">
      <GChart
        v-loading="loading"
        type="PieChart"
        :data="chartData"
        :options="chartOptions"
        :resizeDebounce="500"
        :key="rerender"
        @ready="onChartReady"
      />
    </el-col>
  </el-row>
</template>
<script>
import { GChart } from 'vue-google-charts';
export default {
  name: 'LocationChart',
  components: {
    GChart
  },
  data() {
    return {
      chartData: null,
      loading: true,
      rerender: 0,
      totals: 0,
      chartOptions: {
        chart: {
          title: 'Farmer chart by gender',
          subtitle: 'Jenis kelamin'
        },
        animation: {
          duration: 1200,
          easing: 'out',
          startup: true
        },
        height: 300,
        pieHole: 0.65,
        pieSliceText: 'none',
        slices: [{ color: '#ff4343' }, { color: '#74bd40' }, { color: '#f9bc3f' }, { color: '#0092d2' }, { color: '#0e5faf' }],
        legend: {
          position: 'none',
          align: 'left',
          textStyle: {
            color: { color: '#373737' },
            fontName: 'Nunito',
            fontSize: 18,
            bold: 1
          }
        },
        tooltip: {
          ignoreBounds: true,
          isHtml: true,
          trigger: 'selection'
        }
      }
    };
  },
  computed: {
    registered_location: {
      get: function() {
        const locs = this.$store.getters.registered_location;
        const filtered_locs = [];
        var other_farmer_count = 0;
        var other_percent = 0;
        var i;
        for (i = 0; i < locs.length; i++) {
          if (i < 4) {
            locs[i]['color'] = {
              backgroundColor: this.chartOptions.slices[i].color
            };
            filtered_locs.push(locs[i])
          } else {
            other_farmer_count = other_farmer_count + locs[i]['farmer_count'];
            other_percent = other_percent + locs[i]['percent'];
          }
        }
        filtered_locs.push({
          city_name: 'Lainnya',
          percent: other_percent,
          farmer_count: other_farmer_count,
          color: {
            backgroundColor: this.chartOptions.slices[4].color
          }
        });
        return filtered_locs;
      }
    },
    registered_location_limited: {
      get: function() {
        const locs = this.$store.getters.registered_location;
        const filtered_locs = [];
        var other_farmer_count = 0;
        var other_percent = 0;
        var i;
        for (i = 0; i < locs.length; i++) {
          if (i < 4) {
            locs[i]['color'] = {
              backgroundColor: this.chartOptions.slices[i].color
            };
            filtered_locs.push(locs[i])
          } else {
            other_farmer_count = other_farmer_count + locs[i]['farmer_count'];
            other_percent = (other_farmer_count / this.totals) * 100;
          }
        }
        filtered_locs.push({
          city_name: 'Lainnya',
          percent: other_percent,
          farmer_count: other_farmer_count,
          color: {
            backgroundColor: this.chartOptions.slices[4].color
          }
        });
        return filtered_locs;
      }
    }
  },
  watch: {
    registered_location(newLocation, oldLocation) {
      this.dataLocs = newLocation;
      this.rerender = this.rerender + 1;
    }
  },
  methods: {
    onChartReady(chart, google) {
      this.loading = true;
      this.createDataTable(chart, google);
      setTimeout(() => {
        this.loading = false;
      }, 1.5 * 1000);
    },
    createDataTable(chart, google) {
      const dataArray = [];

      this.dataLocs = this.registered_location;

      if (this.dataLocs !== null) {
        this.dataLocs.forEach((el, index) => {
          if (index < 5) {
            dataArray.push([el.city_name, el.farmer_count]);
          }
        });
      }
      const total = getTotal(dataArray);

      for (let i = 0; i < dataArray.length; i++) {
        dataArray[i].push(customTooltip(dataArray[i][0], dataArray[i][1], total));
      }

      // Changing legend
      for (let i = 0; i < dataArray.length; i++) {
        dataArray[i][0] =
          dataArray[i][0] + ' ' + ((dataArray[i][1] / total) * 100).toFixed(2) + '% ' + dataArray[i][1] + ` Petani`;
      }

      // Column names
      dataArray.unshift(['Location', 'Percentage', 'Tooltip']);

      const dataTable = google.visualization.arrayToDataTable(dataArray);
      dataTable.setColumnProperty(2, 'role', 'tooltip');
      dataTable.setColumnProperty(2, 'html', true);
      dataTable.setColumnProperty(0, 'className', 'jajal');

      function customTooltip(name, value, total) {
        return (
          '<div class="location-tooltip">' +
          '<table class="location-tooltip__box"><tr><td><b>' +
          name +
          '<br/></b></td></tr><tr><td><b>' +
          value +
          '</b><span><img src="https://user-core.s3-ap-southeast-1.amazonaws.com/assets/people-dark-green.svg" /></span></td><td><span><b>(' +
          ((value / total) * 100).toFixed(2) +
          '%)</b></span></td></tr></table></div>'
        );
      }

      function getTotal(dataArray) {
        let total = 0;
        for (let i = 0; i < dataArray.length; i++) {
          total += dataArray[i][1];
        }
        return total;
      }
      this.chartData = dataTable;
      this.totals = total;
      chart.draw(dataTable, this.chartOptions);
    }
  }
};
</script>
<style rel="stylesheet/scss" lang="scss" >
@import '@/styles/variables.scss';
@import '@/styles/mixin.scss';
.google-visualization-tooltip {
  border: none !important;
  box-shadow: none !important;
}
.location-tooltip {
  display: block;
  padding: 10px;
  @include ritx-box;

  &__box {
    td {
      display: inline-flex;
      align-items: center;
    }
  }

  .location-tooltip__featured {
    width: 40px;
    height: 40px;
  }

  table {
    td {
      vertical-align: middle;
      font-size: 18px;
      a {
        font-size: 18px;
        display: inline-flex;
        align-items: center;
        color: #f9bc3f;
      }
    }
  }

  img {
    padding: 5px;
    width: 25px;
    height: 25px;
  }
}

.farmer-count {
  display: inline-block;
  color: #086939;
  font-weight: 700;
  margin-top: 10px;
  &--decimal {
    float: right;
  }

  .svg-icon {
    width: 12px;
    height: 12px;
    vertical-align: 0;
  }
}

.box {
  width: 16px;
  height: 16px;
  background-color: #ff4343;
  margin-right: 10px;
  display: inline-block;
}

.small-table {
  .el-table--medium td {
    padding: 7px 0;
  }
}
</style>
